import { ArgsValue, GetGen, MaybePromise } from 'nexus/dist/core';
import * as yup from 'yup';
import { ObjectShape } from 'yup/lib/object';
declare type Yup = typeof yup;
export declare type ValidateResolver<TypeName extends string, FieldName extends string> = (yup: Yup, args: ArgsValue<TypeName, FieldName>, ctx: GetGen<'context'>) => MaybePromise<ObjectShape | void>;
export interface ValidatePluginErrorConfig {
    error: Error | yup.ValidationError;
    args: any;
    ctx: GetGen<'context'>;
}
export interface ValidatePluginConfig {
    formatError?: (config: ValidatePluginErrorConfig) => Error;
}
export declare const defaultFormatError: ({ error, }: ValidatePluginErrorConfig) => Error;
export declare const validatePlugin: (validateConfig?: ValidatePluginConfig) => import("nexus/dist/plugin").NexusPlugin;
export declare class NexusValidateError extends Error {
    extensions: {
        invalidArgs: string[];
    };
    constructor(message: string, extensions: {
        invalidArgs: string[];
    });
}
export { ValidationError as YupValidationError } from 'yup';
